<form [formGroup]="stockPickerForm">
  <mat-form-field>
    <input
      matInput
      placeholder="Symbol e.g AAPL"
      formControlName="symbol"
      value=""
      (ngModelChange)="fetchQuote()"
    />
    <mat-error>
      <span
        *ngIf="
          !stockPickerForm.get('symbol').valid &&
          stockPickerForm.get('symbol').touched
        ">
        Please enter a symbol
      </span>
    </mat-error>
  </mat-form-field>

  <mat-form-field>
    <mat-label>Favorite time period</mat-label>
    <mat-select
      formControlName="period"
      (ngModelChange)="fetchQuote()"
    >
      <mat-option
        *ngFor="let timePeriod of timePeriods"
        [value]="timePeriod.value"
      >
        {{ timePeriod.viewValue }}
      </mat-option>
    </mat-select>
    <mat-error>
      <span
        *ngIf="
          !stockPickerForm.get('period').valid &&
          stockPickerForm.get('period').touched
        ">
        Please enter a period
      </span>
    </mat-error>
  </mat-form-field>

  <mat-form-field>
    <mat-label>Choose a start date</mat-label>
    <input
      formControlName="startDate"
      matInput
      (ngModelChange)="startDateChanged()"
      [matDatepicker]="startDate"
      [max]="stockPickerForm.get('endDate').value || maxDate">
    <mat-datepicker-toggle matSuffix [for]="startDate"></mat-datepicker-toggle>
    <mat-datepicker #startDate></mat-datepicker>
    <mat-error>
      <span
        *ngIf="
          !stockPickerForm.get('startDate').valid &&
          stockPickerForm.get('startDate').value > maxDate
        ">
        Please choose a date before today
      </span>
    </mat-error>
  </mat-form-field>

  <mat-form-field *ngIf="stockPickerForm.get('startDate').value">
    <mat-label>Choose a end date</mat-label>
    <input
      formControlName="endDate"
      matInput
      [matDatepicker]="endDate"
      [min]="stockPickerForm.get('startDate').value"
      [max]="maxDate">
    <mat-datepicker-toggle matSuffix [for]="endDate"></mat-datepicker-toggle>
    <mat-datepicker #endDate></mat-datepicker>
    <mat-error>
      <span
        *ngIf="
          !stockPickerForm.get('endDate').valid &&
          stockPickerForm.get('endDate').value > maxDate
        ">
        Please choose a date before today
      </span>
    </mat-error>
  </mat-form-field>

  <mat-error>
    {{error$ | async}}
  </mat-error>
  <mat-error>
    <span
      *ngIf="
          !stockPickerForm.get('startDate').valid && stockPickerForm.get('endDate').value &&
          stockPickerForm.get('startDate').value > stockPickerForm.get('endDate').value
        ">
        Start date has to be before the end date!
      </span>
  </mat-error>
  <button
    [disabled]="!stockPickerForm.valid"
    (click)="fetchQuote(false)"
    mat-raised-button>
    Go
  </button>
</form>

<coding-challenge-chart [chartData]="quotes$ | async"></coding-challenge-chart>
